import {
  ChangeDetectionStrategy,
  Component,
  HostBinding,
  Input,
} from "@angular/core";
import {SharedAbstractPresentational} from "@shared/components/presentationals/shared-abstract/shared-abstract.presentational";
import {DataFileStatusEnum} from "@shared/enums/business/data-file-status.enum";
import {StringUtil} from "solidify-frontend";

@Component({
  selector: "dlcm-shared-datafile-quick-status",
  templateUrl: "./shared-datafile-quick-status.presentational.html",
  styleUrls: ["./shared-datafile-quick-status.presentational.scss"],
  changeDetection: ChangeDetectionStrategy.OnPush,
})

export class SharedDatafileQuickStatusPresentational extends SharedAbstractPresentational {
  _value: DataFileStatusEnum;
  @Input()
  set value(value: DataFileStatusEnum) {
    this._value = value;
    this.classes = this.getColor();
  }

  get value(): DataFileStatusEnum {
    return this._value;
  }

  @HostBinding("class")
  classes: string;

  getColor(): string {
    switch (this.value) {
      case DataFileStatusEnum.READY:
        return "ready";
      case DataFileStatusEnum.IN_ERROR:
      case DataFileStatusEnum.EXCLUDED_FILE:
        return "error";
      case DataFileStatusEnum.IGNORED_FILE:
        return "warning";
    }
    return StringUtil.stringEmpty;
  }
}
